<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditTourImGroupInvitationRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="12">
            <el-form-item label="邀请状态 " prop="TourImGroupInvitation.status">
              <el-select
                class="input-item"
                v-model="formData.TourImGroupInvitation.status"
                placeholder=""
                :clearable="true"
                :filterable="true"
                @visible-change="statusWidget.onVisibleChange"
              >
                <el-option
                  v-for="item in statusWidgetDropdownList"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id"
                />
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitTourImGroupInvitationClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditTourImGroupInvitation',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourImGroupInvitationData } from '@/api/generated/tourImGroupInvitationController';
import { TourImGroupInvitationController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const { 
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditTourImGroupInvitationRef = ref();
// 表单数据定义
type FormEditTourImGroupInvitationData = {
  TourImGroupInvitation: TourImGroupInvitationData;
};
// 表单数据
const formData = reactive<FormEditTourImGroupInvitationData>({
  TourImGroupInvitation: {
    // id
    id: undefined,
    // 聊天群组id
    groupId: undefined,
    // 邀请人id
    inviter: undefined,
    // 被邀请人id
    invitee: undefined,
    // 邀请状态 1待确认 2同意 3不同意
    status: undefined,
    // 删除标记 1正常 -1删除
    dataState: undefined,
    // 创建人id
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新时间
    updateTime: undefined,
    // 更新人id
    updateUserId: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourImGroupInvitation.status': [
    {required: true, message: '请输入邀请状态 ', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourImGroupInvitationData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourImGroupInvitation = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourImGroupInvitationController.view(params).then(res => {
      formData.TourImGroupInvitation = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 邀请状态 下拉数据获取函数
 */
const loadStatusDropdownList = (): Promise<ListData<DictData>> => {
  return new Promise((resolve, reject) => {
    DictionaryController.dictGlobalDict({ dictCode: 'GroupInvitationStatus', itemIdType: 'Integer' }).then(res => {
      resolve({
        dataList: res.getList(),
      });
    }).catch(e => {
      reject(e);
    });
  });
};
// 邀请状态 配置参数
const statusOptions: DropdownOptions<DictData> = {
  loadData: loadStatusDropdownList,
  isTree: false,
};
// 邀请状态 下拉组件
const statusWidget = useDropdown(statusOptions);
const { dropdownList: statusWidgetDropdownList } = statusWidget
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditTourImGroupInvitation = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditTourImGroupInvitation = () => {
  refreshFormEditTourImGroupInvitation();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditTourImGroupInvitation();
};
/**
 * 保存
 */
const onSubmitTourImGroupInvitationClick = () => {
  formEditTourImGroupInvitationRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourImGroupInvitation
      };
    retFormData.statusDictMap = findItemFromList(statusWidgetDropdownList.value, retFormData.status, 'id');
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourImGroupInvitationDto: {
        id: formData.TourImGroupInvitation.id,
        groupId: formData.TourImGroupInvitation.groupId,
        inviter: formData.TourImGroupInvitation.inviter,
        invitee: formData.TourImGroupInvitation.invitee,
        status: formData.TourImGroupInvitation.status,
        createUserId: formData.TourImGroupInvitation.createUserId,
        createTime: formData.TourImGroupInvitation.createTime,
        updateTime: formData.TourImGroupInvitation.updateTime,
        updateUserId: formData.TourImGroupInvitation.updateUserId,
      }
    };

    let httpCall = isEdit.value ? TourImGroupInvitationController.update : TourImGroupInvitationController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourImGroupInvitationData().then(res => {
    statusWidget.onVisibleChange(true).catch(e => {console.error(e)});
    if (isEdit.value) refreshFormEditTourImGroupInvitation();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
